
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module Laboratorio7(

	//////////// CLOCK //////////
	CLOCK_50,

	//////////// LED //////////
	LED,

	//////////// KEY //////////
	KEY,

	//////////// SW //////////
	SW,

	//////////// SDRAM //////////
	DRAM_ADDR,
	DRAM_BA,
	DRAM_CAS_N,
	DRAM_CKE,
	DRAM_CLK,
	DRAM_CS_N,
	DRAM_DQ,
	DRAM_DQM,
	DRAM_RAS_N,
	DRAM_WE_N,

	//////////// EPCS //////////
	EPCS_ASDO,
	EPCS_DATA0,
	EPCS_DCLK,
	EPCS_NCSO,

	//////////// Accelerometer and EEPROM //////////
	G_SENSOR_CS_N,
	G_SENSOR_INT,
	I2C_SCLK,
	I2C_SDAT,

	//////////// ADC //////////
	ADC_CS_N,
	ADC_SADDR,
	ADC_SCLK,
	ADC_SDAT,

	//////////// 2x13 GPIO Header //////////
	GPIO_2,
	GPIO_2_IN,

	//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
	GPIO,
	GPIO_IN,

	//////////// GPIO_1, GPIO_1 connect to GPIO Default //////////
	GPIO_B,
	GPIO_B_IN 
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		CLOCK_50;

//////////// LED //////////
output		     [7:0]		LED;

//////////// KEY //////////
input 		     [1:0]		KEY;

//////////// SW //////////
input 		     [3:0]		SW;

//////////// SDRAM //////////
output		    [12:0]		DRAM_ADDR;
output		     [1:0]		DRAM_BA;
output		          		DRAM_CAS_N;
output		          		DRAM_CKE;
output		          		DRAM_CLK;
output		          		DRAM_CS_N;
inout 		    [15:0]		DRAM_DQ;
output		     [1:0]		DRAM_DQM;
output		          		DRAM_RAS_N;
output		          		DRAM_WE_N;

//////////// EPCS //////////
output		          		EPCS_ASDO;
input 		          		EPCS_DATA0;
output		          		EPCS_DCLK;
output		          		EPCS_NCSO;

//////////// Accelerometer and EEPROM //////////
output		          		G_SENSOR_CS_N;
input 		          		G_SENSOR_INT;
output		          		I2C_SCLK;
inout 		          		I2C_SDAT;

//////////// ADC //////////
output		          		ADC_CS_N;
output		          		ADC_SADDR;
output		          		ADC_SCLK;
input 		          		ADC_SDAT;

//////////// 2x13 GPIO Header //////////
inout 		    [12:0]		GPIO_2;
input 		     [2:0]		GPIO_2_IN;

//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
inout 		    [33:0]		GPIO;
input 		     [1:0]		GPIO_IN;

//////////// GPIO_1, GPIO_1 connect to GPIO Default //////////
inout 		    [33:0]		GPIO_B;
input 		     [1:0]		GPIO_B_IN;


//=======================================================
//  REG/WIRE declarations
//=======================================================




//=======================================================
//  Structural coding
//=======================================================
wire [10:0]CounterX;
wire [10:0]CounterY;


reg[3:0] lcd_r_out;
reg[3:0] lcd_g_out;
reg[3:0] lcd_b_out;

wire V_SYNC;
wire H_SYNC;
wire video_on;

assign GPIO[0]=lcd_r_out[3];
assign GPIO[1]=lcd_r_out[2];
assign GPIO[3]=lcd_r_out[1];
assign GPIO[5]=lcd_r_out[0];
assign GPIO[7]=lcd_g_out[3];
assign GPIO[9]=lcd_g_out[2];
assign GPIO[11]=lcd_g_out[1];
assign GPIO[13]=lcd_g_out[0];
assign GPIO[15]=lcd_b_out[3];
assign GPIO[17]=lcd_b_out[2];
assign GPIO[19]=lcd_b_out[1];
assign GPIO[21]=lcd_b_out[0];
assign GPIO[23]=~V_SYNC;
assign GPIO[25]=~H_SYNC;


reg [10:0]pos_x;
reg pos_x_flag =1'b0;
reg [10:0]pos_y;
reg pos_y_flag =1'b0;
wire frame =(CounterX==11'd639)&&(CounterY==11'd479);

wire clk_25mhz;
pll_25mhz pll_25mhz_inst
(
	.inclk0(CLOCK_50) ,	// input  inclk0_sig
	.c0(clk_25mhz) ,	// output  c0_sig
);

mi_vga mi_vga_inst
(
	.clk(clk_25mhz) ,	// input  clk_sig
	.h_sync(H_SYNC) ,	// output  h_sync_sig
	.v_sync(V_SYNC) ,	// output  v_sync_sig
	.video_on(video_on) ,	// output  video_on_sig
	.pixel_x(CounterX) ,	// output [N-1:0] pixel_x_sig
	.pixel_y(CounterY) 	// output [N-1:0] pixel_y_sig
);


////////////////////////////nube////////////////////////////////////////////////////////////////////
wire google_on;
wire [11:0]google_color;
google google_inst
(
	.clk(clk_25mhz) ,	// input  clk_sig
	.scale(4'd0) ,	// input [3:0] scale_sig
	.on_off(1'b1) ,	// input  on_off_sig
	.x_video(CounterX[10:0]) ,	// input [10:0] x_video_sig
	.y_video(CounterY[10:0]) ,	// input [10:0] y_video_sig
	.x_pos(11'd200) ,	// input [10:0] x_pos_sig
	.y_pos(11'd50) ,	// input [10:0] y_pos_sig
	.image_on(google_on) ,	// output  image_on_sig
	.color(google_color[11:0]) 	// output [11:0] color_sig
);
wire nube1_on;
wire [11:0]nube1_color;
test test_inst
(
	.clk(clk_25mhz) ,	// input  clk_sig
	.scale(4'd0) ,	// input [3:0] scale_sig
	.on_off(1'b1) ,	// input  on_off_sig
	.x_video(CounterX[10:0]) ,	// input [10:0] x_video_sig
	.y_video(CounterY[10:0]) ,	// input [10:0] y_video_sig
	.x_pos(pos_x[10:0]) ,	// input [10:0] x_pos_sig
	.y_pos(11'd50) ,	// input [10:0] y_pos_sig
	.image_on(nube1_on) ,	// output  image_on_sig
	.color(nube1_color[11:0]) 	// output [11:0] color_sig
);

wire nube2_on;
wire [11:0]nube2_color;
nube nube_inst2
(
	.clk(clk_25mhz) ,	// input  clk_sig
	.scale(4'd0) ,	// input [3:0] scale_sig
	.on_off(1'b1) ,	// input  on_off_sig
	.x_video(CounterX[10:0]) ,	// input [10:0] x_video_sig
	.y_video(CounterY[10:0]) ,	// input [10:0] y_video_sig
	.x_pos(pos_x[10:0]) ,	// input [10:0] x_pos_sig
	.y_pos(11'd150) ,	// input [10:0] y_pos_sig
	.image_on(nube2_on) ,	// output  image_on_sig
	.color(nube2_color[11:0]) 	// output [11:0] color_sig
);

wire estrella_on;
wire [11:0]estrella_color;
estrella estrella_inst
(
	.clk(clk_25mhz) ,	// input  clk_sig
	.scale(4'd0) ,	// input [3:0] scale_sig
	.on_off(1'b1) ,	// input  on_off_sig
	.x_video(CounterX[10:0]) ,	// input [10:0] x_video_sig
	.y_video(CounterY[10:0]) ,	// input [10:0] y_video_sig
	.x_pos(11'd500) ,	// input [10:0] x_pos_sig
	.y_pos(11'd50) ,	// input [10:0] y_pos_sig
	.image_on(estrella_on) ,	// output  image_on_sig
	.color(estrella_color[11:0]) 	// output [11:0] color_sig
);

wire corazon_on;
wire [11:0]corazon_color;
reg [6:0]conteito;
wire latir_corazon=conteito[5];
always@(posedge frame)
begin
	conteito[6:0]<=conteito[6:0]+1'b1;
end
corazon croazon_inst
(
	.clk(clk_25mhz) ,	// input  clk_sig
	.scale(4'd0+latir_corazon) ,	// input [3:0] scale_sig
	.on_off(1'b1) ,	// input  on_off_sig
	.x_video(CounterX[10:0]) ,	// input [10:0] x_video_sig
	.y_video(CounterY[10:0]) ,	// input [10:0] y_video_sig
	.x_pos(11'd7) ,	// input [10:0] x_pos_sig
	.y_pos(11'd300) ,	// input [10:0] y_pos_sig
	.image_on(corazon_on) ,	// output  image_on_sig
	.color(corazon_color[11:0]) 	// output [11:0] color_sig
); 

wire ani_on;
wire [11:0]ani_color;
ani_nube ani_nube_inst
( 
	.frame(frame) ,	// input  frame_sig
	.clk(clk_25mhz) ,	// input  clk_sig
	.scale(4'd0) ,	// input [3:0] scale_sig
	.on_off(1'b1) ,	// input  on_off_sig
	.x_video(CounterX[10:0]) ,	// input [10:0] x_video_sig
	.y_video(CounterY[10:0]) ,	// input [10:0] y_video_sig
	.x_pos(11'd100) ,	// input [10:0] x_pos_sig
	.y_pos(11'd50) ,	// input [10:0] y_pos_sig
	.image_on(ani_on) ,	// output  image_on_sig
	.color(ani_color[11:0]) 	// output [11:0] color_sig
);

 
wire pasto1_on; 
wire [11:0]pasto1_color;
ani_pasto ani_pasto_inst
(
	.frame(frame) ,	// input  frame_sig
	.clk(clk_25mhz) ,	// input  clk_sig 
	.scale(4'd1) ,	// input [3:0] scale_sig
	.on_off(1'b1) ,	// input  on_off_sig
	.x_video(CounterX[10:0]) ,	// input [10:0] x_video_sig
	.y_video(CounterY[10:0]) ,	// input [10:0] y_video_sig
	.x_pos(11'd0) ,	// input [10:0] x_pos_sig
	.y_pos(11'd429) ,	// input [10:0] y_pos_sig
	.image_on(pasto1_on) ,	// output  image_on_sig
	.color(pasto1_color[11:0]) 	// output [11:0] color_sig
);


/////////////////////////////////////////////////////////////////////////////////////////////////
always@(posedge frame)
begin
	pos_x_flag<=pos_x_flag;
	if(pos_x>=11'd640-11'd100) pos_x_flag<=1'b1;
	else if(pos_x<=11'd1) pos_x_flag<=1'b0;
end

always@(posedge frame)
begin
	pos_y_flag<=pos_y_flag;
	if(pos_y>=11'd480-11'd50) pos_y_flag<=1'b1;
	else if(pos_y<=11'd1) pos_y_flag<=1'b0;
end

always@(posedge frame)
begin
	if(pos_x_flag) pos_x<=pos_x-1'b1;
	else pos_x<=pos_x+1'b1;
end

always@(posedge frame)
begin
	if(pos_y_flag) pos_y<=pos_y-1'b1;
	else pos_y<=pos_y+1'b1;
end


localparam IMAGE_W = 11'd269;
localparam IMAGE_W2 = 11'd45;
localparam IMAGE_H = 11'd56;

reg[5:0]source_frame;
always@(posedge frame)
begin
	if (source_frame[5:3]==3'd5) source_frame<=6'd0;
	else source_frame<=source_frame+1'b1;
end




wire box_on=1'b0;//(CounterX>(pos_x))&&(CounterX<(11'd100+pos_x))&&(CounterY>(pos_y))&&(CounterY<(11'd50+pos_y));
//wire image_on=(CounterX[10:0]>pos_x)&(CounterX[10:0]<=(pos_x+IMAGE_W2-1))&(CounterY[10:0]>pos_y)&(CounterY[10:0]<=(pos_y+IMAGE_H-1));

wire [10:0]offset=(source_frame[5:3]==3'd0)?0:
						(source_frame[5:3]==3'd1)?IMAGE_W2*1:
						(source_frame[5:3]==3'd2)?IMAGE_W2*2:
						(source_frame[5:3]==3'd3)?IMAGE_W2*3:
						(source_frame[5:3]==3'd4)?IMAGE_W2*4:
						IMAGE_W2*5;
						
//wire box_on2=(CounterX>11'd300)&&(CounterX<11'd340)&&(CounterY>11'd220)&&(CounterY<11'd260);

wire [13:0]address_image=(CounterY-pos_y)*IMAGE_W+(CounterX+offset-pos_x[10:0]);
wire[11:0]rgb_image;

wire [3:0]alpha=SW[3:0];
wire [11:0]red_blended=(((rgb_image[11:8]) * alpha) + (4'hf * (4'hf - alpha)))/4'hf;
wire [11:0]green_blended=(((rgb_image[7:4]) * alpha) + (4'h0 * (4'hf - alpha)))/4'hf;
wire [11:0]blue_blended=(((rgb_image[3:0]) * alpha) + (4'h0 * (4'hf - alpha)))/4'hf;

wire render_on;
wire [11:0]render_color; 
ani_chan ani_chan_inst
(
	.frame(frame) ,	// input  frame_sig
	.clk(clk_25mhz) ,	// input  clk_sig
	.scale(4'd0) ,	// input [3:0] scale_sig
	.on_off(1'b1) ,	// input  on_off_sig
	.x_video(CounterX[10:0]) ,	// input [10:0] x_video_sig
	.y_video(CounterY[10:0]) ,	// input [10:0] y_video_sig
	.x_pos(pos_x) ,	// input [10:0] x_pos_sig
	.y_pos(pos_y) ,	// input [10:0] y_pos_sig
	.image_on(render_on) ,	// output  image_on_sig
	.color(render_color[11:0]) 	// output [11:0] color_sig
);
 
//image image_inst
//(
//	.address( address_image ) ,	// input [13:0] address_sig
//	.clock(~clk_25mhz) ,	// input  clock_sig
//	.q(rgb_image) 	// output [11:0] q_sig
//);


/*MUX DE VIDEO*/
always@(negedge clk_25mhz)
begin
	if(!video_on)
	begin
		lcd_r_out<=4'd0;
		lcd_g_out<=4'd0;
		lcd_b_out<=4'd0;
	end
	else
	begin
		lcd_r_out<=4'd0;
		lcd_g_out<=4'h9;
		lcd_b_out<=4'hF;
		if(nube1_on)
		begin
			lcd_r_out<=nube1_color[11:8];
			lcd_g_out<=nube1_color[7:4];
			lcd_b_out<=nube1_color[3:0];
		
		end
		else if(nube2_on)
		begin
			lcd_r_out<=nube2_color[11:8];
			lcd_g_out<=nube2_color[7:4];
			lcd_b_out<=nube2_color[3:0];
		
		end
		else if(estrella_on)
		begin
			lcd_r_out<=estrella_color[11:8];
			lcd_g_out<=estrella_color[7:4];
			lcd_b_out<=estrella_color[3:0];
		
		end
		else if(ani_on)
		begin
			lcd_r_out<=ani_color[11:8];
			lcd_g_out<=ani_color[7:4];
			lcd_b_out<=ani_color[3:0];
		
		end
		else if(corazon_on)
		begin
			lcd_r_out<=corazon_color[11:8];
			lcd_g_out<=corazon_color[7:4];
			lcd_b_out<=corazon_color[3:0];
		
		end 
			else if(pasto1_on)
		begin
			lcd_r_out<=pasto1_color[11:8];
			lcd_g_out<=pasto1_color[7:4];
			lcd_b_out<=pasto1_color[3:0];
		
		end 
		else if(render_on)
		begin
			lcd_r_out<=render_color[11:8];
			lcd_g_out<=render_color[7:4];
			lcd_b_out<=render_color[3:0];
		end
		else if(google_on)
		begin
			lcd_r_out<=google_color[11:8];
			lcd_g_out<=google_color[7:4];
			lcd_b_out<=google_color[3:0];
		end
	end
end



endmodule
