module estrella(input clk,input [3:0]scale,input on_off,input [10:0]x_video,input [10:0]y_video,input [10:0]x_pos,input [10:0]y_pos,output image_on,output [11:0]color);


wire [10:0]real_x=(x_video[10:0]>>scale[3:0])-(x_pos[10:0]>>scale[3:0]);
wire [10:0]real_y=(y_video[10:0]>>scale[3:0])-(y_pos[10:0]>>scale[3:0]);

wire [16:0]bit_pos=real_y[10:0]*49+real_x[10:0];
reg [4:0]datos;
assign image_on= (color[11:0]!=0) & on_off & (real_x[10:0]>11'd0) & (real_x[10:0]<=11'd49)& (real_y[10:0]>11'd0) & (real_y[10:0]<=11'd47);

always@(posedge clk)
begin
  case(bit_pos[16:0])

     24:datos[4:0]<=5'd2;
     72:datos[4:0]<=5'd3; 
     73:datos[4:0]<=5'd4;
     74:datos[4:0]<=5'd3;
     121:datos[4:0]<=5'd5;
     122:datos[4:0]<=5'd4;
     123:datos[4:0]<=5'd5;
     169:datos[4:0]<=5'd3;
     170:datos[4:0]<=5'd4;
     171:datos[4:0]<=5'd4;
     172:datos[4:0]<=5'd4;
     173:datos[4:0]<=5'd3;
     218:datos[4:0]<=5'd5;
     219:datos[4:0]<=5'd4;
     220:datos[4:0]<=5'd4;
     221:datos[4:0]<=5'd4;
     222:datos[4:0]<=5'd5;
     266:datos[4:0]<=5'd3;
     267:datos[4:0]<=5'd4;
     268:datos[4:0]<=5'd4;
     269:datos[4:0]<=5'd4;
     270:datos[4:0]<=5'd4;
     271:datos[4:0]<=5'd4;
     272:datos[4:0]<=5'd3;
     315:datos[4:0]<=5'd5;
     316:datos[4:0]<=5'd4;
     317:datos[4:0]<=5'd4;
     318:datos[4:0]<=5'd4;
     319:datos[4:0]<=5'd4;
     320:datos[4:0]<=5'd4;
     321:datos[4:0]<=5'd5;
     363:datos[4:0]<=5'd3;
     364:datos[4:0]<=5'd4;
     365:datos[4:0]<=5'd4;
     366:datos[4:0]<=5'd4;
     367:datos[4:0]<=5'd4;
     368:datos[4:0]<=5'd4;
     369:datos[4:0]<=5'd4;
     370:datos[4:0]<=5'd4;
     371:datos[4:0]<=5'd3;
     412:datos[4:0]<=5'd5;
     413:datos[4:0]<=5'd4;
     414:datos[4:0]<=5'd4;
     415:datos[4:0]<=5'd4;
     416:datos[4:0]<=5'd4;
     417:datos[4:0]<=5'd4;
     418:datos[4:0]<=5'd4;
     419:datos[4:0]<=5'd4;
     420:datos[4:0]<=5'd5;
     460:datos[4:0]<=5'd6;
     461:datos[4:0]<=5'd4;
     462:datos[4:0]<=5'd4;
     463:datos[4:0]<=5'd4;
     464:datos[4:0]<=5'd4;
     465:datos[4:0]<=5'd4;
     466:datos[4:0]<=5'd4;
     467:datos[4:0]<=5'd4;
     468:datos[4:0]<=5'd4;
     469:datos[4:0]<=5'd4;
     470:datos[4:0]<=5'd6;
     509:datos[4:0]<=5'd7;
     510:datos[4:0]<=5'd4;
     511:datos[4:0]<=5'd4;
     512:datos[4:0]<=5'd4;
     513:datos[4:0]<=5'd4;
     514:datos[4:0]<=5'd4;
     515:datos[4:0]<=5'd4;
     516:datos[4:0]<=5'd4;
     517:datos[4:0]<=5'd4;
     518:datos[4:0]<=5'd4;
     519:datos[4:0]<=5'd7;
     557:datos[4:0]<=5'd8;
     558:datos[4:0]<=5'd4;
     559:datos[4:0]<=5'd4;
     560:datos[4:0]<=5'd4;
     561:datos[4:0]<=5'd4;
     562:datos[4:0]<=5'd4;
     563:datos[4:0]<=5'd4;
     564:datos[4:0]<=5'd4;
     565:datos[4:0]<=5'd4;
     566:datos[4:0]<=5'd4;
     567:datos[4:0]<=5'd4;
     568:datos[4:0]<=5'd4;
     569:datos[4:0]<=5'd8;
     606:datos[4:0]<=5'd7;
     607:datos[4:0]<=5'd4;
     608:datos[4:0]<=5'd4;
     609:datos[4:0]<=5'd4;
     610:datos[4:0]<=5'd4;
     611:datos[4:0]<=5'd4;
     612:datos[4:0]<=5'd4;
     613:datos[4:0]<=5'd4;
     614:datos[4:0]<=5'd4;
     615:datos[4:0]<=5'd4;
     616:datos[4:0]<=5'd4;
     617:datos[4:0]<=5'd4;
     618:datos[4:0]<=5'd7;
     654:datos[4:0]<=5'd8;
     655:datos[4:0]<=5'd4;
     656:datos[4:0]<=5'd4;
     657:datos[4:0]<=5'd4;
     658:datos[4:0]<=5'd4;
     659:datos[4:0]<=5'd4;
     660:datos[4:0]<=5'd4;
     661:datos[4:0]<=5'd4;
     662:datos[4:0]<=5'd4;
     663:datos[4:0]<=5'd4;
     664:datos[4:0]<=5'd4;
     665:datos[4:0]<=5'd4;
     666:datos[4:0]<=5'd4;
     667:datos[4:0]<=5'd4;
     668:datos[4:0]<=5'd8;
     703:datos[4:0]<=5'd7;
     704:datos[4:0]<=5'd4;
     705:datos[4:0]<=5'd4;
     706:datos[4:0]<=5'd4;
     707:datos[4:0]<=5'd4;
     708:datos[4:0]<=5'd4;
     709:datos[4:0]<=5'd4;
     710:datos[4:0]<=5'd4;
     711:datos[4:0]<=5'd4;
     712:datos[4:0]<=5'd4;
     713:datos[4:0]<=5'd4;
     714:datos[4:0]<=5'd4;
     715:datos[4:0]<=5'd4;
     716:datos[4:0]<=5'd4;
     717:datos[4:0]<=5'd7;
     747:datos[4:0]<=5'd6;
     748:datos[4:0]<=5'd3;
     749:datos[4:0]<=5'd9;
     750:datos[4:0]<=5'd10;
     751:datos[4:0]<=5'd5;
     752:datos[4:0]<=5'd4;
     753:datos[4:0]<=5'd4;
     754:datos[4:0]<=5'd4;
     755:datos[4:0]<=5'd4;
     756:datos[4:0]<=5'd4;
     757:datos[4:0]<=5'd4;
     758:datos[4:0]<=5'd4;
     759:datos[4:0]<=5'd4;
     760:datos[4:0]<=5'd4;
     761:datos[4:0]<=5'd4;
     762:datos[4:0]<=5'd4;
     763:datos[4:0]<=5'd4;
     764:datos[4:0]<=5'd4;
     765:datos[4:0]<=5'd4;
     766:datos[4:0]<=5'd4;
     767:datos[4:0]<=5'd5;
     768:datos[4:0]<=5'd10;
     769:datos[4:0]<=5'd9;
     770:datos[4:0]<=5'd3;
     771:datos[4:0]<=5'd6;
     789:datos[4:0]<=5'd8;
     790:datos[4:0]<=5'd3;
     791:datos[4:0]<=5'd9;
     792:datos[4:0]<=5'd10;
     793:datos[4:0]<=5'd5;
     794:datos[4:0]<=5'd11;
     795:datos[4:0]<=5'd4;
     796:datos[4:0]<=5'd4;
     797:datos[4:0]<=5'd4;
     798:datos[4:0]<=5'd4;
     799:datos[4:0]<=5'd4;
     800:datos[4:0]<=5'd4;
     801:datos[4:0]<=5'd4;
     802:datos[4:0]<=5'd4;
     803:datos[4:0]<=5'd4;
     804:datos[4:0]<=5'd4;
     805:datos[4:0]<=5'd4;
     806:datos[4:0]<=5'd4;
     807:datos[4:0]<=5'd4;
     808:datos[4:0]<=5'd4;
     809:datos[4:0]<=5'd4;
     810:datos[4:0]<=5'd4;
     811:datos[4:0]<=5'd4;
     812:datos[4:0]<=5'd4;
     813:datos[4:0]<=5'd4;
     814:datos[4:0]<=5'd4;
     815:datos[4:0]<=5'd4;
     816:datos[4:0]<=5'd4;
     817:datos[4:0]<=5'd4;
     818:datos[4:0]<=5'd4;
     819:datos[4:0]<=5'd4;
     820:datos[4:0]<=5'd4;
     821:datos[4:0]<=5'd4;
     822:datos[4:0]<=5'd11;
     823:datos[4:0]<=5'd5;
     824:datos[4:0]<=5'd10;
     825:datos[4:0]<=5'd9;
     826:datos[4:0]<=5'd3;
     827:datos[4:0]<=5'd8;
     833:datos[4:0]<=5'd12;
     834:datos[4:0]<=5'd9;
     835:datos[4:0]<=5'd5;
     836:datos[4:0]<=5'd13;
     837:datos[4:0]<=5'd4;
     838:datos[4:0]<=5'd4;
     839:datos[4:0]<=5'd4;
     840:datos[4:0]<=5'd4;
     841:datos[4:0]<=5'd4;
     842:datos[4:0]<=5'd4;
     843:datos[4:0]<=5'd4;
     844:datos[4:0]<=5'd4;
     845:datos[4:0]<=5'd4;
     846:datos[4:0]<=5'd4;
     847:datos[4:0]<=5'd4;
     848:datos[4:0]<=5'd4;
     849:datos[4:0]<=5'd4;
     850:datos[4:0]<=5'd4;
     851:datos[4:0]<=5'd4;
     852:datos[4:0]<=5'd4;
     853:datos[4:0]<=5'd4;
     854:datos[4:0]<=5'd4;
     855:datos[4:0]<=5'd4;
     856:datos[4:0]<=5'd4;
     857:datos[4:0]<=5'd4;
     858:datos[4:0]<=5'd4;
     859:datos[4:0]<=5'd4;
     860:datos[4:0]<=5'd4;
     861:datos[4:0]<=5'd4;
     862:datos[4:0]<=5'd4;
     863:datos[4:0]<=5'd4;
     864:datos[4:0]<=5'd4;
     865:datos[4:0]<=5'd4;
     866:datos[4:0]<=5'd4;
     867:datos[4:0]<=5'd4;
     868:datos[4:0]<=5'd4;
     869:datos[4:0]<=5'd4;
     870:datos[4:0]<=5'd4;
     871:datos[4:0]<=5'd4;
     872:datos[4:0]<=5'd4;
     873:datos[4:0]<=5'd4;
     874:datos[4:0]<=5'd4;
     875:datos[4:0]<=5'd4;
     876:datos[4:0]<=5'd4;
     877:datos[4:0]<=5'd4;
     878:datos[4:0]<=5'd13;
     879:datos[4:0]<=5'd5;
     880:datos[4:0]<=5'd9;
     881:datos[4:0]<=5'd12;
     882:datos[4:0]<=5'd14;
     883:datos[4:0]<=5'd13;
     884:datos[4:0]<=5'd4;
     885:datos[4:0]<=5'd4;
     886:datos[4:0]<=5'd4;
     887:datos[4:0]<=5'd4;
     888:datos[4:0]<=5'd4;
     889:datos[4:0]<=5'd4;
     890:datos[4:0]<=5'd4;
     891:datos[4:0]<=5'd4;
     892:datos[4:0]<=5'd4;
     893:datos[4:0]<=5'd4;
     894:datos[4:0]<=5'd4;
     895:datos[4:0]<=5'd4;
     896:datos[4:0]<=5'd4;
     897:datos[4:0]<=5'd4;
     898:datos[4:0]<=5'd4;
     899:datos[4:0]<=5'd4;
     900:datos[4:0]<=5'd4;
     901:datos[4:0]<=5'd15;
     902:datos[4:0]<=5'd16;
     903:datos[4:0]<=5'd16;
     904:datos[4:0]<=5'd15;
     905:datos[4:0]<=5'd4;
     906:datos[4:0]<=5'd4;
     907:datos[4:0]<=5'd4;
     908:datos[4:0]<=5'd15;
     909:datos[4:0]<=5'd16;
     910:datos[4:0]<=5'd16;
     911:datos[4:0]<=5'd15;
     912:datos[4:0]<=5'd4;
     913:datos[4:0]<=5'd4;
     914:datos[4:0]<=5'd4;
     915:datos[4:0]<=5'd4;
     916:datos[4:0]<=5'd4;
     917:datos[4:0]<=5'd4;
     918:datos[4:0]<=5'd4;
     919:datos[4:0]<=5'd4;
     920:datos[4:0]<=5'd4;
     921:datos[4:0]<=5'd4;
     922:datos[4:0]<=5'd4;
     923:datos[4:0]<=5'd4;
     924:datos[4:0]<=5'd4;
     925:datos[4:0]<=5'd4;
     926:datos[4:0]<=5'd4;
     927:datos[4:0]<=5'd4;
     928:datos[4:0]<=5'd4;
     929:datos[4:0]<=5'd13;
     930:datos[4:0]<=5'd14;
     932:datos[4:0]<=5'd14;
     933:datos[4:0]<=5'd13;
     934:datos[4:0]<=5'd4;
     935:datos[4:0]<=5'd4;
     936:datos[4:0]<=5'd4;
     937:datos[4:0]<=5'd4;
     938:datos[4:0]<=5'd4;
     939:datos[4:0]<=5'd4;
     940:datos[4:0]<=5'd4;
     941:datos[4:0]<=5'd4;
     942:datos[4:0]<=5'd4;
     943:datos[4:0]<=5'd4;
     944:datos[4:0]<=5'd4;
     945:datos[4:0]<=5'd4;
     946:datos[4:0]<=5'd4;
     947:datos[4:0]<=5'd4;
     948:datos[4:0]<=5'd4;
     949:datos[4:0]<=5'd4;
     950:datos[4:0]<=5'd17;
     951:datos[4:0]<=5'd16;
     952:datos[4:0]<=5'd16;
     953:datos[4:0]<=5'd17;
     954:datos[4:0]<=5'd4;
     955:datos[4:0]<=5'd4;
     956:datos[4:0]<=5'd4;
     957:datos[4:0]<=5'd17;
     958:datos[4:0]<=5'd16;
     959:datos[4:0]<=5'd16;
     960:datos[4:0]<=5'd17;
     961:datos[4:0]<=5'd4;
     962:datos[4:0]<=5'd4;
     963:datos[4:0]<=5'd4;
     964:datos[4:0]<=5'd4;
     965:datos[4:0]<=5'd4;
     966:datos[4:0]<=5'd4;
     967:datos[4:0]<=5'd4;
     968:datos[4:0]<=5'd4;
     969:datos[4:0]<=5'd4;
     970:datos[4:0]<=5'd4;
     971:datos[4:0]<=5'd4;
     972:datos[4:0]<=5'd4;
     973:datos[4:0]<=5'd4;
     974:datos[4:0]<=5'd4;
     975:datos[4:0]<=5'd4;
     976:datos[4:0]<=5'd4;
     977:datos[4:0]<=5'd13;
     978:datos[4:0]<=5'd14;
     982:datos[4:0]<=5'd14;
     983:datos[4:0]<=5'd13;
     984:datos[4:0]<=5'd4;
     985:datos[4:0]<=5'd4;
     986:datos[4:0]<=5'd4;
     987:datos[4:0]<=5'd4;
     988:datos[4:0]<=5'd4;
     989:datos[4:0]<=5'd4;
     990:datos[4:0]<=5'd4;
     991:datos[4:0]<=5'd4;
     992:datos[4:0]<=5'd4;
     993:datos[4:0]<=5'd4;
     994:datos[4:0]<=5'd4;
     995:datos[4:0]<=5'd4;
     996:datos[4:0]<=5'd4;
     997:datos[4:0]<=5'd4;
     998:datos[4:0]<=5'd4;
     999:datos[4:0]<=5'd16;
     1000:datos[4:0]<=5'd16;
     1001:datos[4:0]<=5'd16;
     1002:datos[4:0]<=5'd16;
     1003:datos[4:0]<=5'd18;
     1004:datos[4:0]<=5'd4;
     1005:datos[4:0]<=5'd4;
     1006:datos[4:0]<=5'd16;
     1007:datos[4:0]<=5'd16;
     1008:datos[4:0]<=5'd16;
     1009:datos[4:0]<=5'd16;
     1010:datos[4:0]<=5'd18;
     1011:datos[4:0]<=5'd4;
     1012:datos[4:0]<=5'd4;
     1013:datos[4:0]<=5'd4;
     1014:datos[4:0]<=5'd4;
     1015:datos[4:0]<=5'd4;
     1016:datos[4:0]<=5'd4;
     1017:datos[4:0]<=5'd4;
     1018:datos[4:0]<=5'd4;
     1019:datos[4:0]<=5'd4;
     1020:datos[4:0]<=5'd4;
     1021:datos[4:0]<=5'd4;
     1022:datos[4:0]<=5'd4;
     1023:datos[4:0]<=5'd4;
     1024:datos[4:0]<=5'd4;
     1025:datos[4:0]<=5'd13;
     1026:datos[4:0]<=5'd14;
     1032:datos[4:0]<=5'd14;
     1033:datos[4:0]<=5'd13;
     1034:datos[4:0]<=5'd4;
     1035:datos[4:0]<=5'd4;
     1036:datos[4:0]<=5'd4;
     1037:datos[4:0]<=5'd4;
     1038:datos[4:0]<=5'd4;
     1039:datos[4:0]<=5'd4;
     1040:datos[4:0]<=5'd4;
     1041:datos[4:0]<=5'd4;
     1042:datos[4:0]<=5'd4;
     1043:datos[4:0]<=5'd4;
     1044:datos[4:0]<=5'd4;
     1045:datos[4:0]<=5'd4;
     1046:datos[4:0]<=5'd4;
     1047:datos[4:0]<=5'd4;
     1048:datos[4:0]<=5'd16;
     1049:datos[4:0]<=5'd16;
     1050:datos[4:0]<=5'd16;
     1051:datos[4:0]<=5'd16;
     1052:datos[4:0]<=5'd18;
     1053:datos[4:0]<=5'd4;
     1054:datos[4:0]<=5'd4;
     1055:datos[4:0]<=5'd16;
     1056:datos[4:0]<=5'd16;
     1057:datos[4:0]<=5'd16;
     1058:datos[4:0]<=5'd16;
     1059:datos[4:0]<=5'd18;
     1060:datos[4:0]<=5'd4;
     1061:datos[4:0]<=5'd4;
     1062:datos[4:0]<=5'd4;
     1063:datos[4:0]<=5'd4;
     1064:datos[4:0]<=5'd4;
     1065:datos[4:0]<=5'd4;
     1066:datos[4:0]<=5'd4;
     1067:datos[4:0]<=5'd4;
     1068:datos[4:0]<=5'd4;
     1069:datos[4:0]<=5'd4;
     1070:datos[4:0]<=5'd4;
     1071:datos[4:0]<=5'd4;
     1072:datos[4:0]<=5'd4;
     1073:datos[4:0]<=5'd13;
     1074:datos[4:0]<=5'd14;
     1082:datos[4:0]<=5'd14;
     1083:datos[4:0]<=5'd7;
     1084:datos[4:0]<=5'd4;
     1085:datos[4:0]<=5'd4;
     1086:datos[4:0]<=5'd4;
     1087:datos[4:0]<=5'd4;
     1088:datos[4:0]<=5'd4;
     1089:datos[4:0]<=5'd4;
     1090:datos[4:0]<=5'd4;
     1091:datos[4:0]<=5'd4;
     1092:datos[4:0]<=5'd4;
     1093:datos[4:0]<=5'd4;
     1094:datos[4:0]<=5'd4;
     1095:datos[4:0]<=5'd4;
     1096:datos[4:0]<=5'd4;
     1097:datos[4:0]<=5'd17;
     1098:datos[4:0]<=5'd16;
     1099:datos[4:0]<=5'd16;
     1100:datos[4:0]<=5'd17;
     1101:datos[4:0]<=5'd4;
     1102:datos[4:0]<=5'd4;
     1103:datos[4:0]<=5'd4;
     1104:datos[4:0]<=5'd17;
     1105:datos[4:0]<=5'd16;
     1106:datos[4:0]<=5'd16;
     1107:datos[4:0]<=5'd17;
     1108:datos[4:0]<=5'd4;
     1109:datos[4:0]<=5'd4;
     1110:datos[4:0]<=5'd4;
     1111:datos[4:0]<=5'd4;
     1112:datos[4:0]<=5'd4;
     1113:datos[4:0]<=5'd4;
     1114:datos[4:0]<=5'd4;
     1115:datos[4:0]<=5'd4;
     1116:datos[4:0]<=5'd4;
     1117:datos[4:0]<=5'd4;
     1118:datos[4:0]<=5'd4;
     1119:datos[4:0]<=5'd4;
     1120:datos[4:0]<=5'd4;
     1121:datos[4:0]<=5'd7;
     1122:datos[4:0]<=5'd14;
     1133:datos[4:0]<=5'd7;
     1134:datos[4:0]<=5'd4;
     1135:datos[4:0]<=5'd4;
     1136:datos[4:0]<=5'd4;
     1137:datos[4:0]<=5'd4;
     1138:datos[4:0]<=5'd4;
     1139:datos[4:0]<=5'd4;
     1140:datos[4:0]<=5'd4;
     1141:datos[4:0]<=5'd4;
     1142:datos[4:0]<=5'd4;
     1143:datos[4:0]<=5'd4;
     1144:datos[4:0]<=5'd4;
     1145:datos[4:0]<=5'd4;
     1146:datos[4:0]<=5'd15;
     1147:datos[4:0]<=5'd16;
     1148:datos[4:0]<=5'd16;
     1149:datos[4:0]<=5'd15;
     1150:datos[4:0]<=5'd4;
     1151:datos[4:0]<=5'd4;
     1152:datos[4:0]<=5'd4;
     1153:datos[4:0]<=5'd15;
     1154:datos[4:0]<=5'd16;
     1155:datos[4:0]<=5'd16;
     1156:datos[4:0]<=5'd15;
     1157:datos[4:0]<=5'd4;
     1158:datos[4:0]<=5'd4;
     1159:datos[4:0]<=5'd4;
     1160:datos[4:0]<=5'd4;
     1161:datos[4:0]<=5'd4;
     1162:datos[4:0]<=5'd4;
     1163:datos[4:0]<=5'd4;
     1164:datos[4:0]<=5'd4;
     1165:datos[4:0]<=5'd4;
     1166:datos[4:0]<=5'd4;
     1167:datos[4:0]<=5'd4;
     1168:datos[4:0]<=5'd4;
     1169:datos[4:0]<=5'd7;
     1183:datos[4:0]<=5'd7;
     1184:datos[4:0]<=5'd4;
     1185:datos[4:0]<=5'd4;
     1186:datos[4:0]<=5'd4;
     1187:datos[4:0]<=5'd4;
     1188:datos[4:0]<=5'd4;
     1189:datos[4:0]<=5'd4;
     1190:datos[4:0]<=5'd4;
     1191:datos[4:0]<=5'd4;
     1192:datos[4:0]<=5'd4;
     1193:datos[4:0]<=5'd4;
     1194:datos[4:0]<=5'd4;
     1195:datos[4:0]<=5'd4;
     1196:datos[4:0]<=5'd18;
     1197:datos[4:0]<=5'd18;
     1198:datos[4:0]<=5'd4;
     1199:datos[4:0]<=5'd4;
     1200:datos[4:0]<=5'd4;
     1201:datos[4:0]<=5'd4;
     1202:datos[4:0]<=5'd4;
     1203:datos[4:0]<=5'd18;
     1204:datos[4:0]<=5'd18;
     1205:datos[4:0]<=5'd4;
     1206:datos[4:0]<=5'd4;
     1207:datos[4:0]<=5'd4;
     1208:datos[4:0]<=5'd4;
     1209:datos[4:0]<=5'd4;
     1210:datos[4:0]<=5'd4;
     1211:datos[4:0]<=5'd4;
     1212:datos[4:0]<=5'd4;
     1213:datos[4:0]<=5'd4;
     1214:datos[4:0]<=5'd4;
     1215:datos[4:0]<=5'd4;
     1216:datos[4:0]<=5'd4;
     1217:datos[4:0]<=5'd7;
     1233:datos[4:0]<=5'd7;
     1234:datos[4:0]<=5'd4;
     1235:datos[4:0]<=5'd4;
     1236:datos[4:0]<=5'd4;
     1237:datos[4:0]<=5'd4;
     1238:datos[4:0]<=5'd4;
     1239:datos[4:0]<=5'd4;
     1240:datos[4:0]<=5'd4;
     1241:datos[4:0]<=5'd4;
     1242:datos[4:0]<=5'd4;
     1243:datos[4:0]<=5'd4;
     1244:datos[4:0]<=5'd4;
     1245:datos[4:0]<=5'd4;
     1246:datos[4:0]<=5'd4;
     1247:datos[4:0]<=5'd4;
     1248:datos[4:0]<=5'd4;
     1249:datos[4:0]<=5'd4;
     1250:datos[4:0]<=5'd4;
     1251:datos[4:0]<=5'd4;
     1252:datos[4:0]<=5'd4;
     1253:datos[4:0]<=5'd4;
     1254:datos[4:0]<=5'd4;
     1255:datos[4:0]<=5'd4;
     1256:datos[4:0]<=5'd4;
     1257:datos[4:0]<=5'd4;
     1258:datos[4:0]<=5'd4;
     1259:datos[4:0]<=5'd4;
     1260:datos[4:0]<=5'd4;
     1261:datos[4:0]<=5'd4;
     1262:datos[4:0]<=5'd4;
     1263:datos[4:0]<=5'd4;
     1264:datos[4:0]<=5'd4;
     1265:datos[4:0]<=5'd7;
     1283:datos[4:0]<=5'd7;
     1284:datos[4:0]<=5'd4;
     1285:datos[4:0]<=5'd4;
     1286:datos[4:0]<=5'd4;
     1287:datos[4:0]<=5'd4;
     1288:datos[4:0]<=5'd4;
     1289:datos[4:0]<=5'd4;
     1290:datos[4:0]<=5'd4;
     1291:datos[4:0]<=5'd4;
     1292:datos[4:0]<=5'd4;
     1293:datos[4:0]<=5'd4;
     1294:datos[4:0]<=5'd4;
     1295:datos[4:0]<=5'd4;
     1296:datos[4:0]<=5'd4;
     1297:datos[4:0]<=5'd4;
     1298:datos[4:0]<=5'd4;
     1299:datos[4:0]<=5'd4;
     1300:datos[4:0]<=5'd4;
     1301:datos[4:0]<=5'd4;
     1302:datos[4:0]<=5'd4;
     1303:datos[4:0]<=5'd4;
     1304:datos[4:0]<=5'd4;
     1305:datos[4:0]<=5'd4;
     1306:datos[4:0]<=5'd4;
     1307:datos[4:0]<=5'd4;
     1308:datos[4:0]<=5'd4;
     1309:datos[4:0]<=5'd4;
     1310:datos[4:0]<=5'd4;
     1311:datos[4:0]<=5'd4;
     1312:datos[4:0]<=5'd4;
     1313:datos[4:0]<=5'd7;
     1333:datos[4:0]<=5'd7;
     1334:datos[4:0]<=5'd4;
     1335:datos[4:0]<=5'd4;
     1336:datos[4:0]<=5'd4;
     1337:datos[4:0]<=5'd4;
     1338:datos[4:0]<=5'd4;
     1339:datos[4:0]<=5'd4;
     1340:datos[4:0]<=5'd4;
     1341:datos[4:0]<=5'd4;
     1342:datos[4:0]<=5'd4;
     1343:datos[4:0]<=5'd4;
     1344:datos[4:0]<=5'd4;
     1345:datos[4:0]<=5'd4;
     1346:datos[4:0]<=5'd4;
     1347:datos[4:0]<=5'd4;
     1348:datos[4:0]<=5'd4;
     1349:datos[4:0]<=5'd4;
     1350:datos[4:0]<=5'd4;
     1351:datos[4:0]<=5'd4;
     1352:datos[4:0]<=5'd4;
     1353:datos[4:0]<=5'd4;
     1354:datos[4:0]<=5'd4;
     1355:datos[4:0]<=5'd4;
     1356:datos[4:0]<=5'd4;
     1357:datos[4:0]<=5'd4;
     1358:datos[4:0]<=5'd4;
     1359:datos[4:0]<=5'd4;
     1360:datos[4:0]<=5'd4;
     1361:datos[4:0]<=5'd7;
     1383:datos[4:0]<=5'd7;
     1384:datos[4:0]<=5'd4;
     1385:datos[4:0]<=5'd4;
     1386:datos[4:0]<=5'd4;
     1387:datos[4:0]<=5'd4;
     1388:datos[4:0]<=5'd4;
     1389:datos[4:0]<=5'd4;
     1390:datos[4:0]<=5'd4;
     1391:datos[4:0]<=5'd4;
     1392:datos[4:0]<=5'd4;
     1393:datos[4:0]<=5'd4;
     1394:datos[4:0]<=5'd4;
     1395:datos[4:0]<=5'd4;
     1396:datos[4:0]<=5'd4;
     1397:datos[4:0]<=5'd4;
     1398:datos[4:0]<=5'd4;
     1399:datos[4:0]<=5'd4;
     1400:datos[4:0]<=5'd4;
     1401:datos[4:0]<=5'd4;
     1402:datos[4:0]<=5'd4;
     1403:datos[4:0]<=5'd4;
     1404:datos[4:0]<=5'd4;
     1405:datos[4:0]<=5'd4;
     1406:datos[4:0]<=5'd4;
     1407:datos[4:0]<=5'd4;
     1408:datos[4:0]<=5'd4;
     1409:datos[4:0]<=5'd7;
     1433:datos[4:0]<=5'd13;
     1434:datos[4:0]<=5'd4;
     1435:datos[4:0]<=5'd4;
     1436:datos[4:0]<=5'd4;
     1437:datos[4:0]<=5'd4;
     1438:datos[4:0]<=5'd4;
     1439:datos[4:0]<=5'd4;
     1440:datos[4:0]<=5'd4;
     1441:datos[4:0]<=5'd4;
     1442:datos[4:0]<=5'd4;
     1443:datos[4:0]<=5'd4;
     1444:datos[4:0]<=5'd4;
     1445:datos[4:0]<=5'd4;
     1446:datos[4:0]<=5'd4;
     1447:datos[4:0]<=5'd4;
     1448:datos[4:0]<=5'd4;
     1449:datos[4:0]<=5'd4;
     1450:datos[4:0]<=5'd4;
     1451:datos[4:0]<=5'd4;
     1452:datos[4:0]<=5'd4;
     1453:datos[4:0]<=5'd4;
     1454:datos[4:0]<=5'd4;
     1455:datos[4:0]<=5'd4;
     1456:datos[4:0]<=5'd4;
     1457:datos[4:0]<=5'd13;
     1482:datos[4:0]<=5'd5;
     1483:datos[4:0]<=5'd4;
     1484:datos[4:0]<=5'd4;
     1485:datos[4:0]<=5'd4;
     1486:datos[4:0]<=5'd4;
     1487:datos[4:0]<=5'd4;
     1488:datos[4:0]<=5'd4;
     1489:datos[4:0]<=5'd4;
     1490:datos[4:0]<=5'd4;
     1491:datos[4:0]<=5'd4;
     1492:datos[4:0]<=5'd4;
     1493:datos[4:0]<=5'd4;
     1494:datos[4:0]<=5'd4;
     1495:datos[4:0]<=5'd4;
     1496:datos[4:0]<=5'd4;
     1497:datos[4:0]<=5'd4;
     1498:datos[4:0]<=5'd4;
     1499:datos[4:0]<=5'd4;
     1500:datos[4:0]<=5'd4;
     1501:datos[4:0]<=5'd4;
     1502:datos[4:0]<=5'd4;
     1503:datos[4:0]<=5'd4;
     1504:datos[4:0]<=5'd4;
     1505:datos[4:0]<=5'd4;
     1506:datos[4:0]<=5'd5;
     1531:datos[4:0]<=5'd4;
     1532:datos[4:0]<=5'd4;
     1533:datos[4:0]<=5'd4;
     1534:datos[4:0]<=5'd4;
     1535:datos[4:0]<=5'd4;
     1536:datos[4:0]<=5'd4;
     1537:datos[4:0]<=5'd4;
     1538:datos[4:0]<=5'd4;
     1539:datos[4:0]<=5'd4;
     1540:datos[4:0]<=5'd4;
     1541:datos[4:0]<=5'd4;
     1542:datos[4:0]<=5'd4;
     1543:datos[4:0]<=5'd4;
     1544:datos[4:0]<=5'd4;
     1545:datos[4:0]<=5'd4;
     1546:datos[4:0]<=5'd4;
     1547:datos[4:0]<=5'd4;
     1548:datos[4:0]<=5'd4;
     1549:datos[4:0]<=5'd4;
     1550:datos[4:0]<=5'd4;
     1551:datos[4:0]<=5'd4;
     1552:datos[4:0]<=5'd4;
     1553:datos[4:0]<=5'd4;
     1554:datos[4:0]<=5'd4;
     1555:datos[4:0]<=5'd4;
     1579:datos[4:0]<=5'd6;
     1580:datos[4:0]<=5'd4;
     1581:datos[4:0]<=5'd4;
     1582:datos[4:0]<=5'd4;
     1583:datos[4:0]<=5'd4;
     1584:datos[4:0]<=5'd4;
     1585:datos[4:0]<=5'd4;
     1586:datos[4:0]<=5'd4;
     1587:datos[4:0]<=5'd4;
     1588:datos[4:0]<=5'd4;
     1589:datos[4:0]<=5'd4;
     1590:datos[4:0]<=5'd4;
     1591:datos[4:0]<=5'd4;
     1592:datos[4:0]<=5'd4;
     1593:datos[4:0]<=5'd4;
     1594:datos[4:0]<=5'd4;
     1595:datos[4:0]<=5'd4;
     1596:datos[4:0]<=5'd4;
     1597:datos[4:0]<=5'd4;
     1598:datos[4:0]<=5'd4;
     1599:datos[4:0]<=5'd4;
     1600:datos[4:0]<=5'd4;
     1601:datos[4:0]<=5'd4;
     1602:datos[4:0]<=5'd4;
     1603:datos[4:0]<=5'd4;
     1604:datos[4:0]<=5'd4;
     1605:datos[4:0]<=5'd6;
     1628:datos[4:0]<=5'd12;
     1629:datos[4:0]<=5'd4;
     1630:datos[4:0]<=5'd4;
     1631:datos[4:0]<=5'd4;
     1632:datos[4:0]<=5'd4;
     1633:datos[4:0]<=5'd4;
     1634:datos[4:0]<=5'd4;
     1635:datos[4:0]<=5'd4;
     1636:datos[4:0]<=5'd4;
     1637:datos[4:0]<=5'd4;
     1638:datos[4:0]<=5'd4;
     1639:datos[4:0]<=5'd4;
     1640:datos[4:0]<=5'd4;
     1641:datos[4:0]<=5'd4;
     1642:datos[4:0]<=5'd4;
     1643:datos[4:0]<=5'd4;
     1644:datos[4:0]<=5'd4;
     1645:datos[4:0]<=5'd4;
     1646:datos[4:0]<=5'd4;
     1647:datos[4:0]<=5'd4;
     1648:datos[4:0]<=5'd4;
     1649:datos[4:0]<=5'd4;
     1650:datos[4:0]<=5'd4;
     1651:datos[4:0]<=5'd4;
     1652:datos[4:0]<=5'd4;
     1653:datos[4:0]<=5'd4;
     1654:datos[4:0]<=5'd12;
     1677:datos[4:0]<=5'd2;
     1678:datos[4:0]<=5'd4;
     1679:datos[4:0]<=5'd4;
     1680:datos[4:0]<=5'd4;
     1681:datos[4:0]<=5'd4;
     1682:datos[4:0]<=5'd4;
     1683:datos[4:0]<=5'd4;
     1684:datos[4:0]<=5'd4;
     1685:datos[4:0]<=5'd4;
     1686:datos[4:0]<=5'd4;
     1687:datos[4:0]<=5'd4;
     1688:datos[4:0]<=5'd4;
     1689:datos[4:0]<=5'd4;
     1690:datos[4:0]<=5'd4;
     1691:datos[4:0]<=5'd4;
     1692:datos[4:0]<=5'd4;
     1693:datos[4:0]<=5'd4;
     1694:datos[4:0]<=5'd4;
     1695:datos[4:0]<=5'd4;
     1696:datos[4:0]<=5'd4;
     1697:datos[4:0]<=5'd4;
     1698:datos[4:0]<=5'd4;
     1699:datos[4:0]<=5'd4;
     1700:datos[4:0]<=5'd4;
     1701:datos[4:0]<=5'd4;
     1702:datos[4:0]<=5'd4;
     1703:datos[4:0]<=5'd2;
     1726:datos[4:0]<=5'd19;
     1727:datos[4:0]<=5'd4;
     1728:datos[4:0]<=5'd4;
     1729:datos[4:0]<=5'd4;
     1730:datos[4:0]<=5'd4;
     1731:datos[4:0]<=5'd4;
     1732:datos[4:0]<=5'd4;
     1733:datos[4:0]<=5'd4;
     1734:datos[4:0]<=5'd4;
     1735:datos[4:0]<=5'd4;
     1736:datos[4:0]<=5'd4;
     1737:datos[4:0]<=5'd4;
     1738:datos[4:0]<=5'd4;
     1739:datos[4:0]<=5'd4;
     1740:datos[4:0]<=5'd4;
     1741:datos[4:0]<=5'd4;
     1742:datos[4:0]<=5'd4;
     1743:datos[4:0]<=5'd4;
     1744:datos[4:0]<=5'd4;
     1745:datos[4:0]<=5'd4;
     1746:datos[4:0]<=5'd4;
     1747:datos[4:0]<=5'd4;
     1748:datos[4:0]<=5'd4;
     1749:datos[4:0]<=5'd4;
     1750:datos[4:0]<=5'd4;
     1751:datos[4:0]<=5'd4;
     1752:datos[4:0]<=5'd19;
     1775:datos[4:0]<=5'd13;
     1776:datos[4:0]<=5'd4;
     1777:datos[4:0]<=5'd4;
     1778:datos[4:0]<=5'd4;
     1779:datos[4:0]<=5'd4;
     1780:datos[4:0]<=5'd4;
     1781:datos[4:0]<=5'd4;
     1782:datos[4:0]<=5'd4;
     1783:datos[4:0]<=5'd4;
     1784:datos[4:0]<=5'd4;
     1785:datos[4:0]<=5'd4;
     1786:datos[4:0]<=5'd4;
     1787:datos[4:0]<=5'd4;
     1788:datos[4:0]<=5'd4;
     1789:datos[4:0]<=5'd4;
     1790:datos[4:0]<=5'd4;
     1791:datos[4:0]<=5'd4;
     1792:datos[4:0]<=5'd4;
     1793:datos[4:0]<=5'd4;
     1794:datos[4:0]<=5'd4;
     1795:datos[4:0]<=5'd4;
     1796:datos[4:0]<=5'd4;
     1797:datos[4:0]<=5'd4;
     1798:datos[4:0]<=5'd4;
     1799:datos[4:0]<=5'd4;
     1800:datos[4:0]<=5'd4;
     1801:datos[4:0]<=5'd13;
     1824:datos[4:0]<=5'd4;
     1825:datos[4:0]<=5'd4;
     1826:datos[4:0]<=5'd4;
     1827:datos[4:0]<=5'd4;
     1828:datos[4:0]<=5'd4;
     1829:datos[4:0]<=5'd4;
     1830:datos[4:0]<=5'd4;
     1831:datos[4:0]<=5'd4;
     1832:datos[4:0]<=5'd4;
     1833:datos[4:0]<=5'd4;
     1834:datos[4:0]<=5'd4;
     1835:datos[4:0]<=5'd4;
     1836:datos[4:0]<=5'd4;
     1837:datos[4:0]<=5'd4;
     1838:datos[4:0]<=5'd4;
     1839:datos[4:0]<=5'd4;
     1840:datos[4:0]<=5'd4;
     1841:datos[4:0]<=5'd4;
     1842:datos[4:0]<=5'd4;
     1843:datos[4:0]<=5'd4;
     1844:datos[4:0]<=5'd4;
     1845:datos[4:0]<=5'd4;
     1846:datos[4:0]<=5'd4;
     1847:datos[4:0]<=5'd4;
     1848:datos[4:0]<=5'd4;
     1849:datos[4:0]<=5'd4;
     1850:datos[4:0]<=5'd4;
     1872:datos[4:0]<=5'd6;
     1873:datos[4:0]<=5'd4;
     1874:datos[4:0]<=5'd4;
     1875:datos[4:0]<=5'd4;
     1876:datos[4:0]<=5'd4;
     1877:datos[4:0]<=5'd4;
     1878:datos[4:0]<=5'd4;
     1879:datos[4:0]<=5'd4;
     1880:datos[4:0]<=5'd4;
     1881:datos[4:0]<=5'd4;
     1882:datos[4:0]<=5'd4;
     1883:datos[4:0]<=5'd4;
     1884:datos[4:0]<=5'd4;
     1885:datos[4:0]<=5'd5;
     1886:datos[4:0]<=5'd20;
     1887:datos[4:0]<=5'd5;
     1888:datos[4:0]<=5'd4;
     1889:datos[4:0]<=5'd4;
     1890:datos[4:0]<=5'd4;
     1891:datos[4:0]<=5'd4;
     1892:datos[4:0]<=5'd4;
     1893:datos[4:0]<=5'd4;
     1894:datos[4:0]<=5'd4;
     1895:datos[4:0]<=5'd4;
     1896:datos[4:0]<=5'd4;
     1897:datos[4:0]<=5'd4;
     1898:datos[4:0]<=5'd4;
     1899:datos[4:0]<=5'd4;
     1900:datos[4:0]<=5'd6;
     1921:datos[4:0]<=5'd12;
     1922:datos[4:0]<=5'd4;
     1923:datos[4:0]<=5'd4;
     1924:datos[4:0]<=5'd4;
     1925:datos[4:0]<=5'd4;
     1926:datos[4:0]<=5'd4;
     1927:datos[4:0]<=5'd4;
     1928:datos[4:0]<=5'd4;
     1929:datos[4:0]<=5'd4;
     1930:datos[4:0]<=5'd4;
     1931:datos[4:0]<=5'd4;
     1932:datos[4:0]<=5'd11;
     1933:datos[4:0]<=5'd3;
     1937:datos[4:0]<=5'd3;
     1938:datos[4:0]<=5'd11;
     1939:datos[4:0]<=5'd4;
     1940:datos[4:0]<=5'd4;
     1941:datos[4:0]<=5'd4;
     1942:datos[4:0]<=5'd4;
     1943:datos[4:0]<=5'd4;
     1944:datos[4:0]<=5'd4;
     1945:datos[4:0]<=5'd4;
     1946:datos[4:0]<=5'd4;
     1947:datos[4:0]<=5'd4;
     1948:datos[4:0]<=5'd4;
     1949:datos[4:0]<=5'd12;
     1970:datos[4:0]<=5'd2;
     1971:datos[4:0]<=5'd4;
     1972:datos[4:0]<=5'd4;
     1973:datos[4:0]<=5'd4;
     1974:datos[4:0]<=5'd4;
     1975:datos[4:0]<=5'd4;
     1976:datos[4:0]<=5'd4;
     1977:datos[4:0]<=5'd4;
     1978:datos[4:0]<=5'd4;
     1979:datos[4:0]<=5'd11;
     1980:datos[4:0]<=5'd20;
     1988:datos[4:0]<=5'd20;
     1989:datos[4:0]<=5'd11;
     1990:datos[4:0]<=5'd4;
     1991:datos[4:0]<=5'd4;
     1992:datos[4:0]<=5'd4;
     1993:datos[4:0]<=5'd4;
     1994:datos[4:0]<=5'd4;
     1995:datos[4:0]<=5'd4;
     1996:datos[4:0]<=5'd4;
     1997:datos[4:0]<=5'd4;
     1998:datos[4:0]<=5'd2;
     2019:datos[4:0]<=5'd5;
     2020:datos[4:0]<=5'd4;
     2021:datos[4:0]<=5'd4;
     2022:datos[4:0]<=5'd4;
     2023:datos[4:0]<=5'd4;
     2024:datos[4:0]<=5'd4;
     2025:datos[4:0]<=5'd4;
     2026:datos[4:0]<=5'd11;
     2027:datos[4:0]<=5'd20;
     2039:datos[4:0]<=5'd20;
     2040:datos[4:0]<=5'd11;
     2041:datos[4:0]<=5'd4;
     2042:datos[4:0]<=5'd4;
     2043:datos[4:0]<=5'd4;
     2044:datos[4:0]<=5'd4;
     2045:datos[4:0]<=5'd4;
     2046:datos[4:0]<=5'd4;
     2047:datos[4:0]<=5'd5;
     2068:datos[4:0]<=5'd11;
     2069:datos[4:0]<=5'd4;
     2070:datos[4:0]<=5'd4;
     2071:datos[4:0]<=5'd4;
     2072:datos[4:0]<=5'd4;
     2073:datos[4:0]<=5'd21;
     2074:datos[4:0]<=5'd2;
     2075:datos[4:0]<=5'd14;
     2089:datos[4:0]<=5'd14;
     2090:datos[4:0]<=5'd2;
     2091:datos[4:0]<=5'd21;
     2092:datos[4:0]<=5'd4;
     2093:datos[4:0]<=5'd4;
     2094:datos[4:0]<=5'd4;
     2095:datos[4:0]<=5'd4;
     2096:datos[4:0]<=5'd11;
     2117:datos[4:0]<=5'd4;
     2118:datos[4:0]<=5'd4;
     2119:datos[4:0]<=5'd4;
     2120:datos[4:0]<=5'd21;
     2121:datos[4:0]<=5'd2;
     2122:datos[4:0]<=5'd14;
     2140:datos[4:0]<=5'd14;
     2141:datos[4:0]<=5'd2;
     2142:datos[4:0]<=5'd21;
     2143:datos[4:0]<=5'd4;
     2144:datos[4:0]<=5'd4;
     2145:datos[4:0]<=5'd4;
     2165:datos[4:0]<=5'd3;
     2166:datos[4:0]<=5'd4;
     2167:datos[4:0]<=5'd4;
     2168:datos[4:0]<=5'd2;
     2169:datos[4:0]<=5'd14;
     2191:datos[4:0]<=5'd14;
     2192:datos[4:0]<=5'd2;
     2193:datos[4:0]<=5'd4;
     2194:datos[4:0]<=5'd4;
     2195:datos[4:0]<=5'd3;
     2214:datos[4:0]<=5'd20;
     2215:datos[4:0]<=5'd7;
     2216:datos[4:0]<=5'd22;
     2242:datos[4:0]<=5'd22;
     2243:datos[4:0]<=5'd7;
     2244:datos[4:0]<=5'd20;
     2263:datos[4:0]<=5'd4;
     2293:datos[4:0]<=5'd4;
     default: datos[4:0]<=5'h0;

   endcase
end

//Map Color
assign color[11:0]=          (datos[4:0]==1)?12'd0:
          (datos[4:0]==2)?12'd1888:
          (datos[4:0]==3)?12'd1072:
          (datos[4:0]==4)?12'd4032:
          (datos[4:0]==5)?12'd2960:
          (datos[4:0]==6)?12'd800:
          (datos[4:0]==7)?12'd2416:
          (datos[4:0]==8)?12'd544:
          (datos[4:0]==9)?12'd2144:
          (datos[4:0]==10)?12'd2160:
          (datos[4:0]==11)?12'd3488:
          (datos[4:0]==12)?12'd1344:
          (datos[4:0]==13)?12'd3232:
          (datos[4:0]==14)?12'd272:
          (datos[4:0]==15)?12'd3201:
          (datos[4:0]==16)?12'd3123:
          (datos[4:0]==17)?12'd2866:
          (datos[4:0]==18)?12'd4016:
          (datos[4:0]==19)?12'd2688:
          (datos[4:0]==20)?12'd1600:
          (datos[4:0]==21)?12'd3760:
          (datos[4:0]==22)?12'd528:
             12'd0;


endmodule
