module render3(input clk,input [3:0]scale,input on_off,input [10:0]x_video,input [10:0]y_video,input [10:0]x_pos,input [10:0]y_pos,output image_on,output [11:0]color);


wire [10:0]real_x=(x_video[10:0]>>scale[3:0])-(x_pos[10:0]>>scale[3:0]);
wire [10:0]real_y=(y_video[10:0]>>scale[3:0])-(y_pos[10:0]>>scale[3:0]);

wire [14:0]bit_pos=real_y[10:0]*25+real_x[10:0];
reg [3:0]datos;
assign image_on= (color[11:0]!=1638) & on_off & (real_x[10:0]>11'd0) & (real_x[10:0]<=11'd25)& (real_y[10:0]>11'd0) & (real_y[10:0]<=11'd30);

always@(posedge clk)
begin
  case(bit_pos[14:0])

     13:datos[3:0]<=4'd2;
     14:datos[3:0]<=4'd2;
     16:datos[3:0]<=4'd2;
     17:datos[3:0]<=4'd2;
     37:datos[3:0]<=4'd2;
     38:datos[3:0]<=4'd3;
     39:datos[3:0]<=4'd4;
     40:datos[3:0]<=4'd2;
     41:datos[3:0]<=4'd3;
     42:datos[3:0]<=4'd4;
     43:datos[3:0]<=4'd2;
     61:datos[3:0]<=4'd2;
     62:datos[3:0]<=4'd5;
     63:datos[3:0]<=4'd3;
     64:datos[3:0]<=4'd4;
     65:datos[3:0]<=4'd4;
     66:datos[3:0]<=4'd3;
     67:datos[3:0]<=4'd4;
     68:datos[3:0]<=4'd4;
     69:datos[3:0]<=4'd2;
     83:datos[3:0]<=4'd2;
     84:datos[3:0]<=4'd2;
     85:datos[3:0]<=4'd2;
     86:datos[3:0]<=4'd2;
     87:datos[3:0]<=4'd5;
     88:datos[3:0]<=4'd3;
     89:datos[3:0]<=4'd4;
     90:datos[3:0]<=4'd4;
     91:datos[3:0]<=4'd3;
     92:datos[3:0]<=4'd4;
     93:datos[3:0]<=4'd4;
     94:datos[3:0]<=4'd2;
     107:datos[3:0]<=4'd2;
     108:datos[3:0]<=4'd6;
     109:datos[3:0]<=4'd7;
     110:datos[3:0]<=4'd7;
     111:datos[3:0]<=4'd2;
     112:datos[3:0]<=4'd5;
     113:datos[3:0]<=4'd3;
     114:datos[3:0]<=4'd4;
     115:datos[3:0]<=4'd4;
     116:datos[3:0]<=4'd5;
     117:datos[3:0]<=4'd3;
     118:datos[3:0]<=4'd4;
     119:datos[3:0]<=4'd2;
     132:datos[3:0]<=4'd2;
     133:datos[3:0]<=4'd8;
     134:datos[3:0]<=4'd6;
     135:datos[3:0]<=4'd2;
     136:datos[3:0]<=4'd2;
     137:datos[3:0]<=4'd5;
     138:datos[3:0]<=4'd3;
     139:datos[3:0]<=4'd4;
     140:datos[3:0]<=4'd5;
     141:datos[3:0]<=4'd2;
     142:datos[3:0]<=4'd3;
     143:datos[3:0]<=4'd4;
     144:datos[3:0]<=4'd2;
     145:datos[3:0]<=4'd2;
     146:datos[3:0]<=4'd2;
     157:datos[3:0]<=4'd2;
     158:datos[3:0]<=4'd2;
     159:datos[3:0]<=4'd2;
     160:datos[3:0]<=4'd4;
     161:datos[3:0]<=4'd4;
     162:datos[3:0]<=4'd2;
     163:datos[3:0]<=4'd2;
     164:datos[3:0]<=4'd2;
     165:datos[3:0]<=4'd2;
     166:datos[3:0]<=4'd4;
     167:datos[3:0]<=4'd2;
     168:datos[3:0]<=4'd2;
     169:datos[3:0]<=4'd4;
     170:datos[3:0]<=4'd4;
     171:datos[3:0]<=4'd4;
     172:datos[3:0]<=4'd2;
     181:datos[3:0]<=4'd2;
     182:datos[3:0]<=4'd7;
     183:datos[3:0]<=4'd2;
     184:datos[3:0]<=4'd3;
     185:datos[3:0]<=4'd4;
     186:datos[3:0]<=4'd9;
     187:datos[3:0]<=4'd4;
     188:datos[3:0]<=4'd4;
     189:datos[3:0]<=4'd4;
     190:datos[3:0]<=4'd4;
     191:datos[3:0]<=4'd4;
     192:datos[3:0]<=4'd4;
     193:datos[3:0]<=4'd4;
     194:datos[3:0]<=4'd4;
     195:datos[3:0]<=4'd9;
     196:datos[3:0]<=4'd9;
     197:datos[3:0]<=4'd4;
     198:datos[3:0]<=4'd2;
     205:datos[3:0]<=4'd2;
     206:datos[3:0]<=4'd8;
     207:datos[3:0]<=4'd6;
     208:datos[3:0]<=4'd2;
     209:datos[3:0]<=4'd3;
     210:datos[3:0]<=4'd4;
     211:datos[3:0]<=4'd4;
     212:datos[3:0]<=4'd9;
     213:datos[3:0]<=4'd9;
     214:datos[3:0]<=4'd9;
     215:datos[3:0]<=4'd4;
     216:datos[3:0]<=4'd3;
     217:datos[3:0]<=4'd4;
     218:datos[3:0]<=4'd4;
     219:datos[3:0]<=4'd4;
     220:datos[3:0]<=4'd2;
     221:datos[3:0]<=4'd9;
     222:datos[3:0]<=4'd2;
     223:datos[3:0]<=4'd2;
     230:datos[3:0]<=4'd2;
     231:datos[3:0]<=4'd8;
     232:datos[3:0]<=4'd8;
     233:datos[3:0]<=4'd2;
     234:datos[3:0]<=4'd5;
     235:datos[3:0]<=4'd3;
     236:datos[3:0]<=4'd9;
     237:datos[3:0]<=4'd9;
     238:datos[3:0]<=4'd9;
     239:datos[3:0]<=4'd9;
     240:datos[3:0]<=4'd3;
     241:datos[3:0]<=4'd3;
     242:datos[3:0]<=4'd4;
     243:datos[3:0]<=4'd4;
     244:datos[3:0]<=4'd4;
     245:datos[3:0]<=4'd4;
     246:datos[3:0]<=4'd4;
     247:datos[3:0]<=4'd4;
     248:datos[3:0]<=4'd4;
     249:datos[3:0]<=4'd2;
     256:datos[3:0]<=4'd2;
     257:datos[3:0]<=4'd2;
     258:datos[3:0]<=4'd2;
     259:datos[3:0]<=4'd5;
     260:datos[3:0]<=4'd3;
     261:datos[3:0]<=4'd9;
     262:datos[3:0]<=4'd9;
     263:datos[3:0]<=4'd9;
     264:datos[3:0]<=4'd9;
     265:datos[3:0]<=4'd5;
     266:datos[3:0]<=4'd3;
     267:datos[3:0]<=4'd3;
     268:datos[3:0]<=4'd4;
     269:datos[3:0]<=4'd4;
     270:datos[3:0]<=4'd4;
     271:datos[3:0]<=4'd4;
     272:datos[3:0]<=4'd4;
     273:datos[3:0]<=4'd4;
     274:datos[3:0]<=4'd2;
     282:datos[3:0]<=4'd2;
     283:datos[3:0]<=4'd2;
     284:datos[3:0]<=4'd5;
     285:datos[3:0]<=4'd5;
     286:datos[3:0]<=4'd10;
     287:datos[3:0]<=4'd9;
     288:datos[3:0]<=4'd9;
     289:datos[3:0]<=4'd10;
     290:datos[3:0]<=4'd2;
     291:datos[3:0]<=4'd5;
     292:datos[3:0]<=4'd3;
     293:datos[3:0]<=4'd3;
     294:datos[3:0]<=4'd3;
     295:datos[3:0]<=4'd4;
     296:datos[3:0]<=4'd4;
     297:datos[3:0]<=4'd4;
     298:datos[3:0]<=4'd3;
     299:datos[3:0]<=4'd2;
     307:datos[3:0]<=4'd2;
     308:datos[3:0]<=4'd6;
     309:datos[3:0]<=4'd2;
     310:datos[3:0]<=4'd5;
     311:datos[3:0]<=4'd5;
     312:datos[3:0]<=4'd10;
     313:datos[3:0]<=4'd10;
     314:datos[3:0]<=4'd2;
     315:datos[3:0]<=4'd2;
     316:datos[3:0]<=4'd5;
     317:datos[3:0]<=4'd5;
     318:datos[3:0]<=4'd3;
     319:datos[3:0]<=4'd3;
     320:datos[3:0]<=4'd3;
     321:datos[3:0]<=4'd3;
     322:datos[3:0]<=4'd3;
     323:datos[3:0]<=4'd3;
     324:datos[3:0]<=4'd2;
     333:datos[3:0]<=4'd2;
     334:datos[3:0]<=4'd2;
     335:datos[3:0]<=4'd2;
     336:datos[3:0]<=4'd5;
     337:datos[3:0]<=4'd5;
     338:datos[3:0]<=4'd10;
     339:datos[3:0]<=4'd9;
     340:datos[3:0]<=4'd2;
     341:datos[3:0]<=4'd5;
     342:datos[3:0]<=4'd5;
     343:datos[3:0]<=4'd5;
     344:datos[3:0]<=4'd5;
     345:datos[3:0]<=4'd3;
     346:datos[3:0]<=4'd3;
     347:datos[3:0]<=4'd3;
     348:datos[3:0]<=4'd2;
     358:datos[3:0]<=4'd2;
     359:datos[3:0]<=4'd6;
     360:datos[3:0]<=4'd2;
     361:datos[3:0]<=4'd5;
     362:datos[3:0]<=4'd3;
     363:datos[3:0]<=4'd10;
     364:datos[3:0]<=4'd10;
     365:datos[3:0]<=4'd9;
     366:datos[3:0]<=4'd2;
     367:datos[3:0]<=4'd5;
     368:datos[3:0]<=4'd5;
     369:datos[3:0]<=4'd5;
     370:datos[3:0]<=4'd5;
     371:datos[3:0]<=4'd2;
     372:datos[3:0]<=4'd2;
     380:datos[3:0]<=4'd2;
     381:datos[3:0]<=4'd2;
     382:datos[3:0]<=4'd2;
     383:datos[3:0]<=4'd2;
     384:datos[3:0]<=4'd2;
     385:datos[3:0]<=4'd5;
     386:datos[3:0]<=4'd3;
     387:datos[3:0]<=4'd3;
     388:datos[3:0]<=4'd10;
     389:datos[3:0]<=4'd10;
     390:datos[3:0]<=4'd10;
     391:datos[3:0]<=4'd2;
     392:datos[3:0]<=4'd2;
     393:datos[3:0]<=4'd2;
     394:datos[3:0]<=4'd2;
     395:datos[3:0]<=4'd2;
     404:datos[3:0]<=4'd2;
     405:datos[3:0]<=4'd6;
     406:datos[3:0]<=4'd9;
     407:datos[3:0]<=4'd6;
     408:datos[3:0]<=4'd2;
     409:datos[3:0]<=4'd4;
     410:datos[3:0]<=4'd4;
     411:datos[3:0]<=4'd3;
     412:datos[3:0]<=4'd9;
     413:datos[3:0]<=4'd9;
     414:datos[3:0]<=4'd9;
     415:datos[3:0]<=4'd2;
     427:datos[3:0]<=4'd2;
     428:datos[3:0]<=4'd2;
     429:datos[3:0]<=4'd6;
     430:datos[3:0]<=4'd6;
     431:datos[3:0]<=4'd6;
     432:datos[3:0]<=4'd2;
     433:datos[3:0]<=4'd2;
     434:datos[3:0]<=4'd4;
     435:datos[3:0]<=4'd4;
     436:datos[3:0]<=4'd2;
     437:datos[3:0]<=4'd9;
     438:datos[3:0]<=4'd9;
     439:datos[3:0]<=4'd9;
     440:datos[3:0]<=4'd2;
     450:datos[3:0]<=4'd2;
     451:datos[3:0]<=4'd2;
     452:datos[3:0]<=4'd2;
     453:datos[3:0]<=4'd9;
     454:datos[3:0]<=4'd2;
     455:datos[3:0]<=4'd2;
     456:datos[3:0]<=4'd2;
     457:datos[3:0]<=4'd9;
     458:datos[3:0]<=4'd2;
     459:datos[3:0]<=4'd4;
     460:datos[3:0]<=4'd4;
     461:datos[3:0]<=4'd2;
     462:datos[3:0]<=4'd2;
     463:datos[3:0]<=4'd9;
     464:datos[3:0]<=4'd9;
     465:datos[3:0]<=4'd2;
     475:datos[3:0]<=4'd2;
     476:datos[3:0]<=4'd4;
     477:datos[3:0]<=4'd3;
     478:datos[3:0]<=4'd2;
     479:datos[3:0]<=4'd9;
     480:datos[3:0]<=4'd9;
     481:datos[3:0]<=4'd9;
     482:datos[3:0]<=4'd2;
     483:datos[3:0]<=4'd2;
     484:datos[3:0]<=4'd4;
     485:datos[3:0]<=4'd4;
     486:datos[3:0]<=4'd4;
     487:datos[3:0]<=4'd2;
     488:datos[3:0]<=4'd2;
     489:datos[3:0]<=4'd9;
     490:datos[3:0]<=4'd2;
     500:datos[3:0]<=4'd2;
     501:datos[3:0]<=4'd9;
     502:datos[3:0]<=4'd5;
     503:datos[3:0]<=4'd3;
     504:datos[3:0]<=4'd2;
     505:datos[3:0]<=4'd2;
     506:datos[3:0]<=4'd2;
     507:datos[3:0]<=4'd2;
     508:datos[3:0]<=4'd3;
     509:datos[3:0]<=4'd4;
     510:datos[3:0]<=4'd4;
     511:datos[3:0]<=4'd2;
     512:datos[3:0]<=4'd4;
     513:datos[3:0]<=4'd2;
     514:datos[3:0]<=4'd2;
     525:datos[3:0]<=4'd2;
     526:datos[3:0]<=4'd9;
     527:datos[3:0]<=4'd9;
     528:datos[3:0]<=4'd5;
     529:datos[3:0]<=4'd3;
     530:datos[3:0]<=4'd4;
     531:datos[3:0]<=4'd4;
     532:datos[3:0]<=4'd2;
     533:datos[3:0]<=4'd3;
     534:datos[3:0]<=4'd4;
     535:datos[3:0]<=4'd9;
     536:datos[3:0]<=4'd9;
     537:datos[3:0]<=4'd4;
     538:datos[3:0]<=4'd2;
     539:datos[3:0]<=4'd2;
     540:datos[3:0]<=4'd2;
     551:datos[3:0]<=4'd2;
     552:datos[3:0]<=4'd11;
     553:datos[3:0]<=4'd9;
     554:datos[3:0]<=4'd9;
     555:datos[3:0]<=4'd3;
     556:datos[3:0]<=4'd3;
     557:datos[3:0]<=4'd2;
     558:datos[3:0]<=4'd5;
     559:datos[3:0]<=4'd3;
     560:datos[3:0]<=4'd4;
     561:datos[3:0]<=4'd4;
     562:datos[3:0]<=4'd4;
     563:datos[3:0]<=4'd2;
     564:datos[3:0]<=4'd2;
     565:datos[3:0]<=4'd2;
     576:datos[3:0]<=4'd2;
     577:datos[3:0]<=4'd11;
     578:datos[3:0]<=4'd11;
     579:datos[3:0]<=4'd9;
     580:datos[3:0]<=4'd9;
     581:datos[3:0]<=4'd9;
     582:datos[3:0]<=4'd11;
     583:datos[3:0]<=4'd2;
     584:datos[3:0]<=4'd5;
     585:datos[3:0]<=4'd3;
     586:datos[3:0]<=4'd4;
     587:datos[3:0]<=4'd2;
     588:datos[3:0]<=4'd2;
     589:datos[3:0]<=4'd4;
     590:datos[3:0]<=4'd2;
     602:datos[3:0]<=4'd2;
     603:datos[3:0]<=4'd2;
     604:datos[3:0]<=4'd2;
     605:datos[3:0]<=4'd2;
     606:datos[3:0]<=4'd2;
     607:datos[3:0]<=4'd2;
     608:datos[3:0]<=4'd11;
     609:datos[3:0]<=4'd2;
     610:datos[3:0]<=4'd2;
     611:datos[3:0]<=4'd2;
     612:datos[3:0]<=4'd10;
     613:datos[3:0]<=4'd2;
     614:datos[3:0]<=4'd2;
     627:datos[3:0]<=4'd2;
     628:datos[3:0]<=4'd8;
     629:datos[3:0]<=4'd6;
     630:datos[3:0]<=4'd7;
     631:datos[3:0]<=4'd7;
     632:datos[3:0]<=4'd2;
     633:datos[3:0]<=4'd10;
     634:datos[3:0]<=4'd10;
     635:datos[3:0]<=4'd2;
     636:datos[3:0]<=4'd2;
     637:datos[3:0]<=4'd2;
     652:datos[3:0]<=4'd2;
     653:datos[3:0]<=4'd8;
     654:datos[3:0]<=4'd6;
     655:datos[3:0]<=4'd7;
     656:datos[3:0]<=4'd7;
     657:datos[3:0]<=4'd2;
     658:datos[3:0]<=4'd2;
     659:datos[3:0]<=4'd2;
     660:datos[3:0]<=4'd7;
     661:datos[3:0]<=4'd2;
     662:datos[3:0]<=4'd2;
     663:datos[3:0]<=4'd2;
     676:datos[3:0]<=4'd2;
     677:datos[3:0]<=4'd8;
     678:datos[3:0]<=4'd8;
     679:datos[3:0]<=4'd8;
     680:datos[3:0]<=4'd6;
     681:datos[3:0]<=4'd9;
     682:datos[3:0]<=4'd7;
     683:datos[3:0]<=4'd2;
     684:datos[3:0]<=4'd8;
     685:datos[3:0]<=4'd6;
     686:datos[3:0]<=4'd7;
     687:datos[3:0]<=4'd7;
     688:datos[3:0]<=4'd9;
     689:datos[3:0]<=4'd2;
     701:datos[3:0]<=4'd2;
     702:datos[3:0]<=4'd8;
     703:datos[3:0]<=4'd8;
     704:datos[3:0]<=4'd6;
     705:datos[3:0]<=4'd7;
     706:datos[3:0]<=4'd7;
     707:datos[3:0]<=4'd7;
     708:datos[3:0]<=4'd2;
     709:datos[3:0]<=4'd8;
     710:datos[3:0]<=4'd8;
     711:datos[3:0]<=4'd6;
     712:datos[3:0]<=4'd6;
     713:datos[3:0]<=4'd7;
     714:datos[3:0]<=4'd2;
     726:datos[3:0]<=4'd2;
     727:datos[3:0]<=4'd2;
     728:datos[3:0]<=4'd2;
     729:datos[3:0]<=4'd2;
     730:datos[3:0]<=4'd2;
     731:datos[3:0]<=4'd2;
     732:datos[3:0]<=4'd2;
     733:datos[3:0]<=4'd2;
     734:datos[3:0]<=4'd2;
     735:datos[3:0]<=4'd2;
     736:datos[3:0]<=4'd2;
     737:datos[3:0]<=4'd2;
     738:datos[3:0]<=4'd2;
     739:datos[3:0]<=4'd2;
     default: datos[3:0]<=4'h0;

   endcase
end

//Map Color
assign color[11:0]=          (datos[3:0]==1)?12'd1638:
          (datos[3:0]==2)?12'd0:
          (datos[3:0]==3)?12'd160:
          (datos[3:0]==4)?12'd240:
          (datos[3:0]==5)?12'd96:
          (datos[3:0]==6)?12'd3906:
          (datos[3:0]==7)?12'd3968:
          (datos[3:0]==8)?12'd2098:
          (datos[3:0]==9)?12'd4095:
          (datos[3:0]==10)?12'd4026:
          (datos[3:0]==11)?12'd4060:
             12'd1638;


endmodule
